#include    "def21160.h"
#define N       512

/* DM data */
.section/dm seg_dmda;
/*data to be transmitted to SHARC*/
.var dest[N];

/* PM interrupt vector code */
.section/pm   seg_rth;
Reserved_1:     rti; nop; nop; nop;
Chip_Reset:     idle; jump begin; nop; nop;

/* program memory code */
.section/pm seg_pmco;

begin:

			ustat1 = dm(SYSCON);	/* Clear Buffer Hang Disable	*/
			bit clr ustat1 0x10000; 
			dm(SYSCON) = ustat1;
			
			
			r0=0;			/*clear link control registers*/
			dm(LAR)=r0;	    
			dm(LCTL0)=r0;


/* set up dma pointers */
/* DMA channel 8=LBUF4, DMA channel 6=LBUF2  */

			r0=dest;
			dm(II8)=r0;
	
			r0=1;
			dm(IM8)=r0;

			r0=@dest;
			dm(C8)=r0;

			r0=0x4000;				/* LBUF4->LPORT4, all other ports are disabled */
			dm(LAR)=r0;	 
			r0=0x10C00;	/*LBUF4 enable port and dma, receive,word size, 1/2 clock, 4bit data path*/
			dm(LCTL1)=r0;	

/*always write LCTLx after LAR*/

/* terminate and wait */
wait: 
nop;
jump wait;

