#include    "def21160.h"
#define N       0xffffff


.SECTION/PM     seg_rth;

		NOP;NOP;NOP;NOP;				// Reserved interrupt

// Vector for RESET:
___lib_RSTI: 	IDLE;					// Implicit IDLE instruction
				JUMP begin;				// Begin program
				NOP;					// Pad to next interrupt
				NOP;					// Pad to next interrupt

// Vector for illegal input condition detected:
___lib_IICD: 	NOP;
				NOP;
				RTI;
				RTI;

// Vector for status stack/loop stack overflow or PC stack full:
___lib_SOVFI:   NOP;
				NOP;
                RTI;
                RTI;

// Vector for high priority timer interrupt:
___lib_TMZHI:   bit tgl FLAGS FLG2;
				bit TGL FLAGS FLG1 | FLG3;
                RTI;
                RTI;

// Vector for Vector Interrupt:
___lib_VIRPTI:  NOP;
				NOP;
                RTI;
                RTI;

// Vector for Hardware Interrupt 2 (IRQ2):
___lib_IRQ2I:   NOP;
				NOP;
                RTI;
                RTI;

// Vector for Hardware Interrupt 1 (IRQ1):
___lib_IRQ1I:   NOP;
				NOP;
                RTI;
                RTI;

// Vector for Hardware Interrupt 0 (IRQ0):
___lib_IRQ0I:   NOP;
				NOP;
                RTI;
                RTI;

                NOP;NOP;NOP;NOP;		// Reserved interrupt

// Vectors for Serial port DMA channels:
___lib_SPR0I:   NOP;
				NOP;
                RTI;
                RTI;

___lib_SPR1I:   NOP;
				NOP;
                RTI;
                RTI;

___lib_SPT0I:   NOP;
				NOP;
                RTI;
                RTI;

___lib_SPT1I:   NOP;
				NOP;
                RTI;
                RTI;

// Vectors for link port DMA channels:
___lib_LP0I : 	NOP;
				NOP;
				RTI;
				RTI;

___lib_LP1I : 	NOP;
				NOP;
				RTI;
				RTI;

___lib_LP2I:    NOP;
				NOP;
                RTI;
                RTI;

___lib_LP3I:    NOP;
				NOP;
                RTI;
                RTI;

___lib_LP4I:    NOP;
				NOP;
                RTI;
                RTI;

___lib_LP5I:    NOP;
				NOP;
                RTI;
                RTI;

// Vectors for External port DMA channels:
___lib_EP0I:    NOP;
				NOP;
				RTI;
				RTI;

___lib_EP1I:    NOP;
				NOP;
				RTI;
				RTI;

___lib_EP2I:    NOP;
				NOP;
				RTI;
				RTI;

___lib_EP3I:  	NOP;
				NOP;
				RTI;
				RTI;

// Vector for Link service request:
___lib_LSRQ:    NOP;
				NOP;
				RTI;
				RTI;

// Vector for DAG1 buffer 7 circular buffer overflow:
___lib_CB7I:    NOP;
				NOP;
				RTI;
				RTI;

// Vector for DAG2 buffer 15 circular buffer overflow:
___lib_CB15I:   NOP;
				NOP;
				RTI;
				RTI;

// Vector for lower priority timer interrupt:
___lib_TMZLI:   NOP;
				NOP;
				RTI;
				RTI;

// Vector for fixed-point overflow interrupt:
___lib_FIXI:	NOP;
				NOP;
				RTI;
				RTI;

// Vector for floating-point overflow interrupt:
___lib_FLTOI:	NOP;
				NOP;
				RTI;
				RTI;

// Vector for floating-point underflow interrupt:
___lib_FLTUI:	NOP;
				NOP;
				RTI;
				RTI;

// Vector for floating-point invalid interrupt:
___lib_FLTII:	NOP;
				NOP;
				RTI;
				RTI;

// Vector for user software interrupt 0:
___lib_SFT0I:	NOP;
				NOP;
				RTI;
				RTI;

// Vector for user software interrupt 1:
___lib_SFT1I:	NOP;
				NOP;
				RTI;
				RTI;

// Vector for user software interrupt 2:
___lib_SFT2I:	NOP;
				NOP;
				RTI;
				RTI;

// Vector for user software interrupt 3:
___lib_SFT3I:	NOP;
				NOP;
				RTI;
				RTI;
/* program memory code */
.section/pm seg_pmco;

begin:

bit set MODE2 FLG1O | FLG2O | FLG3O;	/*Flag1, Flag2 and Flag3 OUTPUT*/
bit set FLAGS FLG1 | FLG3;
tperiod = N-1;
tcount = tperiod;
bit set IMASK 0x10;
bit set MODE1 0x1000;
bit set MODE2 0x20;


/* terminate and wait */
 
wait: nop;
jump wait;


